
/*===============================================*\

	Mardi 3 novembre 1998

	Arash HABIBI

	Erreur.c

	Introduit des erreurs dans les trames.
	C'est un modele de cable non-fiable. 
	Soit des erreurs de bits soit des erreurs
	de caracteres. 

\*================================================*/


#include "Erreur.h"


void IntroduitErreur(char *chaine, int taille, int TypeDErreur, float taux)
/*===============================================*\
	NB_TYPE_ERREUR vaut 4 pour l'instant. 
\*===============================================*/
{
  if(TypeDErreur==0)/* n'introduit aucune erreur */; 
  else if(TypeDErreur==1) IntroduitErreur1(chaine, taille); 
  else if(TypeDErreur==2) IntroduitErreur2(chaine, taille, taux); 
  else if(TypeDErreur==3) IntroduitErreur3(chaine, taille); 
  else if(TypeDErreur==4) IntroduitErreur4(chaine, taille, taux); 
  else {printf("%d : le type d'erreur est un entier compris entre 0 et %d.\n",
  NB_TYPE_ERREUR); exit(1);}
}


void IntroduitErreur1(char *chaine, int taille)
/*===============================================*\
  Dans chaque caractere bloc de deux octets change 
  un bit au hasard.
  Attention si on change un bit dans chaque 
  caractere, alors ca fait plus qu'une erreur par
  caractere code et Hamming ne pourra plus la 
  detecter (!!!)
\*===============================================*/
{
  int i, exposant; 
  unsigned char mask; 

  for(i=0; i<taille; i+=2)
    {
      exposant = (int)floor(drand48() * 16); 
      if(exposant<8)
	{
	  mask = 1<<exposant; 
	  chaine[i] = (chaine[i])^mask;
	}
      else
	{
	  mask = 1<<(exposant-8); 
	  chaine[i+1] = (chaine[i+1])^mask;
	}
    }
}



void IntroduitErreur2(char *chaine, int taille, float taux)
/*===============================================*\
  Pour taux=1 change un bit au hasard dans
  tous les caracteres de la chaine. 
  Pour taux=0 ne change rien du tout. 
  Entre les deux valeurs, toutes les situations 
  intermediaires sont possibles. 
\*===============================================*/
{
  int i, exposant; 
  unsigned char mask; 

  for(i=0; i<taille; i++)
    if(drand48()<taux)
      {
	exposant = (int)floor(drand48() * 16); 
	if(exposant<8)
	  {
	    mask = 1<<exposant; 
	    chaine[i] = (chaine[i])^mask;
	  }
	else
	  {
	    mask = 1<<(exposant-8); 
	    chaine[i+1] = (chaine[i+1])^mask;
	  }
      }
}




void IntroduitErreur3(char *chaine, int taille)
/*===============================================*\
  Change un caractere au hasard dans chaque chaine. 
\*===============================================*/
{
  int indice, offset; 

  indice = (int)floor(drand48() * taille); 
  offset = (int)floor(drand48() * 256); 
  chaine[indice] = (chaine[indice] + offset )%256; 
}


void IntroduitErreur4(char *chaine, int taille, float taux)
/*===============================================*\
  Pour taux change tous les caracteres
  dans chaine. 
  Pour taux ne change rien du tout. 
  Entre les deux valeurs, toutes les situations 
  intermediaires sont possibles. 
\*===============================================*/
{
  int i, offset;

  for(i=0; i<taille; i++)
      if(drand48()<taux)
	{
	  offset = (int)floor(drand48() * 256); 
	  chaine[i] = (chaine[i] + offset )% 256; 
	}
}

