
/*===============================================*\
	Samedi 21 novembre 1998

	Arash HABIBI

	Physique.c

	Tout ce qui a un rapport plus ou moins
	lointain avec la couche physique. 

\*================================================*/


#include "Physique.h"

Medium_t medium[MAX_MEDIUM];
int nb_mediums=0; 


int PhysConnectRequest(char *adresse_loc_name, char *adresse_dist_name)
/*================================================*\
  ouvre et attache la socket. 
\*================================================*/
{
  if(nb_mediums+1>=MAX_MEDIUM)
    {
      printf("Le nombre maximal de mediums : %d\n", 
	     MAX_MEDIUM); return(-1);
    }
  else
    {
      strcpy((medium[nb_mediums]).adresse_loc_name, adresse_loc_name);
      (medium[nb_mediums]).desc_sock    = GetAndBindSocket(adresse_loc_name);
      (medium[nb_mediums]).adresse_dist = PrepareAdresse(adresse_dist_name); 
      (medium[nb_mediums]).Connecte = 1; /* connecte = VRAI */
      printf("Couche physique prete.\n");
      
      return(nb_mediums++);
    }
}


void PhysDataRequest(int desc, char *trame, int taille_trame)
/*================================================*\  
\*================================================*/
{
  int taille_emis, taille_adresse=110; 

  if((desc<0)||(desc>nb_mediums-1))
    {
      printf("Le descripteur de medium doit etre compris entre 0 et %d (et non %d)\n", 
	    0, nb_mediums-1, desc); exit(1);
    }
  else
    {
      taille_emis = sendto(medium[desc].desc_sock, trame,  
			   taille_trame, 0, 
			   (struct sockaddr*) &(medium[desc].adresse_dist), 
			   taille_adresse);
      
      if(taille_emis<=0) {perror("Phys sendto"); exit(1);}
    }
}



int PhysDataIndication(int desc, char *trame)
/*================================================*\  
\*================================================*/
{
  int taille_trame, taille_adresse=110; 
  struct sockaddr_un adresse_dist; 

  if((desc<0)||(desc>nb_mediums-1))
    {
      printf("Le descripteur de medium doit etre compris entre 0 et %d (et non %d)\n", 
	    0, nb_mediums-1, desc); return(-1);
    }
  else
    {
      taille_trame = recvfrom(medium[desc].desc_sock, trame, MAX_TRAME, 0, 
			      (struct sockaddr *) &adresse_dist,
			      &taille_adresse);
      
      if(taille_trame<=0)
	{perror("Phys : recvfrom"); return(-1);}
      
      else if((taille_trame==1)&&(trame[0]=='.'))
	{
	  (medium[nb_mediums]).Connecte = 0; /* connecte = FAUX */
	  return(0); 
	}

      else /* taille_trame > 0 : tout va bien */
	return(taille_trame); 
    }
}


  
void PhysDisconnectRequest(int desc)
/*================================================*\
\*================================================*/
{
  int res, taille_adresse=110; 

  if((desc<0)||(desc>nb_mediums-1))
    {
      printf("Le descripteur de medium doit etre compris entre 0 et %d (et non %d)\n", 
	    0, nb_mediums-1, desc); exit(1);
    }
  else
    {
      if(sendto(medium[desc].desc_sock, ".", 1, 0, 
		(struct sockaddr*) &(medium[desc].adresse_dist), 
		taille_adresse)==-1)
	{perror("sendto deconnect"); exit(1);}

      printf("Couche physique : echange termine.\n");
      close(medium[desc].desc_sock);
      remove(medium[desc].adresse_loc_name);
    }
}


int PhysDisconnectIndication(int desc)
/*================================================*\
\*================================================*/
{
  if((desc<0)||(desc>nb_mediums-1))
    {
      printf("Le descripteur de medium doit etre compris entre 0 et %d (et non %d)\n", 
	    0, nb_mediums-1, desc); exit(1);
    }
  else
    {
      if((medium[nb_mediums]).Connecte != 0) return(0);
      else return(1);
    }
}



void PhysDisconnectRespond(int desc)
/*================================================*\
\*================================================*/
{
  if((desc<0)||(desc>nb_mediums-1))
    {
      printf("Le descripteur de medium doit etre compris entre 0 et %d (et non %d)\n", 
	    0, nb_mediums-1, desc); exit(1);
    }
  else
    {
      printf("Couche physique : echange termine.\n");
      close(medium[desc].desc_sock);
      remove(medium[desc].adresse_loc_name);
    }
}
