
/*================================================*\

	Lundi 23 novembre 1998

	Arash HABIBI

	Physique.h

        Tout ce qui concerne la couche physique

\*================================================*/


#ifndef _PHYS_H
#define _PHYS_H

#include "define.h"
#include "Toolbox.h"

#include <sys/socket.h>
#include <sys/un.h>
#include <string.h>

typedef struct CouchePhys_t
{				/* les descripteurs de tubes */
  int				/* representant les SAP      */
    Data_PL,			/* Data Physique a Liaion    */
    Data_LP,			/* Data Liaison a Physique   */
    Dcnx_PL,			/* Deconnexion Phys a Lia    */
    Dcnx_LP;			/* Deconnexion Lia a Phys    */
    
  char LocalSocketName[50];	/* Nom de la socket locale   */
  char DistantSocketName[50];	/* Nom de la socket distante */
  
  int desc_sock;		/* descripteur de la socket  */
  struct sockaddr_un adresse_loc;
  struct sockaddr_un adresse_dist;

} CouchePhys_t;


extern void InitCouchePhys(CouchePhys_t *CchPhys, char *loc, char *dist, int data_p2l, int data_l2p, int disc_p2l, int disc_l2p);
extern void FreeCouchePhys(CouchePhys_t *CchPhys); 

void SetLocAdrSock(char *ref, CouchePhys_t *);
void SetDstAdrSock(char *ref, CouchePhys_t *);

int Phys_SendData(CouchePhys_t *);
int Phys_ReceiveData(CouchePhys_t *);  
int Phys_Disconnect(CouchePhys_t *);

void Phys_Loop(CouchePhys_t *);


#endif
