/*==================================================*\

  Lundi 22 novembre 1998

  Arash Habibi

  Timer.H

  Inspire de ~/Recherche.d/vfilm.d/Vfilm14.0.d/Timer.H
  
  Contrairement au timer de vfilm, on cherche a avoir
  un timer qui nous donne un seul signal et qui l'indique
  dans une autre fonction. 
  Il faut juste faire Timer->Start(nb_sec); 
  ensuite, il faut tester Timer->Expired() pour savoir
  si le timeout est fini ou non. 

\*==================================================*/


#ifndef _TIMER_H
#define _TIMER_H

#include <stdio.h>
#include <unistd.h>
#include <sys/time.h>
#include <signal.h>
#include <sys/signal.h>

#include <math.h>

#include "define.H"


class Timer_c
{
public:
    Timer_c(); 
    ~Timer_c();

    void Start(long duree);
    void Stop(long duree);
    boolean Expired();
    
private:
    struct itimerval _timer; 
    struct itimerval _old_timer; 
    struct sigaction _p_action; 
    struct sigaction _p_action_anc;
    
    boolean _expired; 

    sigset_t _masque; 
    sigset_t _demasque; 
    
    static void _Handler(); 
};

#endif
