
/*================================================*\

	Mardi 24 novembre 1998

	Arash HABIBI

	Liaison.h

        Tout ce qui concerne la couche Liaison

\*================================================*/


#ifndef _LIAISON_H
#define _LIAISON_H

#include "define.h"
#include "Toolbox.h"
#include "Select.h"

#include <string.h>

typedef struct CoucheLia_t
{				/* les descripteurs de tubes */
  int				/* representant les SAP      */
    Data_PL,			/* Data Physique a Liaion    */
    Data_LP,			/* Data Liaison a Physique   */
    Dcnx_PL,			/* Deconnexion Phys a Lia    */
    Dcnx_LP;			/* Deconnexion Lia a Phys    */

  int 
    Data_LA,			/* Data Liaison a Appli      */
    Data_AL,			/* Data Appli a Liaison      */
    Cnx_LA,			/* Connect Liaison a Appli   */
    Cnx_AL,			/* Connect Appli a Liaison   */
    Dcnx_LA,			/* Deconnect Liaison a Appli */
    Dcnx_AL;			/* Deconnect Appli a Liaison */

} CoucheLia_t;


extern void InitCoucheLia(CoucheLia_t *lia, int em-rec, int data_p2l, int data_l2p, int disc_p2l, int disc_l2p);
extern void FreeCouchePhys(CouchePhys_t *CchPhys); 

void SetLocAdrSock(char *ref, CouchePhys_t *);
void SetDstAdrSock(char *ref, CouchePhys_t *);

int Phys_SendData(CouchePhys_t *);
int Phys_ReceiveData(CouchePhys_t *);  
int Phys_Disconnect(CouchePhys_t *);

void Phys_Loop(CouchePhys_t *);


#endif
