
/*================================================*\

	Lundi 23 novembre 1998

	Arash HABIBI

	Physique.h

        Tout ce qui concerne la couche physique

\*================================================*/


#ifndef _APPLI_H
#define _APPLI_H

#include "define.h"
#include "Toolbox.h"
#include "Attente.h"

#define MAX_PROMPT 100

#define ENVOI 0
#define HELP 1
#define DODO 2
#define BEEP 3
#define QUIT 4

typedef struct CoucheAppli_t
{				/* les descripteurs de tubes */
  int				/* representant les SAP      */
    Conn_AL,			/* Connexion Appli a Liaion  */
    Conn_LA,			/* Connexion Liaion a Appli  */
    Data_AL,			/* Data Appli a Liaion       */
    Data_LA,			/* Data Liaison a Appli      */
    Disc_AL,			/* Deconnexion Appli a Lia   */
    Disc_LA;			/* Deconnexion Lia a Appli   */
  
  int identite;			/* 0 ou 1 selon qu'on est */
				/* station1 ou station2   */
  char prompt[MAX_PROMPT];

  boolean fils_termine;		/* VRAI si les fils ont -----*/
				/* termine et FAUX sinon --- */
} CoucheAppli_t;


void InitCoucheAppli(CoucheAppli_t *CchAppli, int id, int data_al, int data_la, int disc_al, int disc_la);
extern void FreeCoucheAppli(CoucheAppli_t *CchAppli); 

void Appli_ViderTubeInterface(int tube);
int  Appli_OpenTerminal();
void Appli_WritePrompt(int terminal, char *prompt);
int  Appli_OpenFichEmis(char *nomfich);
int  Appli_OpenFichRecu(int numero);
void Appli_Help();
int  Appli_ReceiveData(int Data_LA, int FichRecu);
int  Appli_EmitData(int Data_AL, int FichEmis);
void Appli_DisconnectRequest(int Disc_AL);
void Appli_DisconnectRespond(int Disc_AL);
int  Appli_LectCommande(int terminal, char *nomfich);

void Appli_Boucle(CoucheAppli_t *CchAppli);

#endif
