
/*================================================*\

	Samedi 21 novembre 1998

	Arash HABIBI

	main.c

	Se contente de lancer application et liaison
	reserve des tubes pour la communication 
	entre les couches. Deux tubes pour chaque
	service. 

\*================================================*/


#include <stdio.h>
#include <string.h>
#include <unistd.h>


#include "Application.h"
#include "Liaison.h"
#include "Physique.h"

void main(int argc, char **argv)
/*================================================*\
\*================================================*/
{ 
  CoucheAppli_t CchAppli;
  CoucheLia_t   CchLia;
  CouchePhys_t   CchPhys;

  int connect_appli_lia[2], 
    connect_lia_appli[2], 
    data_appli_lia[2], 
    data_lia_appli[2], 
    disconnect_appli_lia[2], 
    disconnect_lia_appli[2], 
  
    data_phys_lia[2], 
    data_lia_phys[2], 
    disconnect_phys_lia[2], 
    disconnect_lia_phys[2];
  
  if((argc!=2)||((atoi(argv[1])!=1)&&(atoi(argv[1])!=2)))
    {printf("Usage : station indice\navec indice=1 ou indice=2\n");
    exit(1);}
  
  /*--------------- ouverture des tubes ----------------*/
		      
  if(pipe(connect_appli_lia)==-1)
    perror("connect_appli_lia");
  
  if(pipe(connect_lia_appli)==-1)
    perror("connect_lia_appli");
  
  if(pipe(data_appli_lia)==-1)
    perror("data_appli_lia");
  
  if(pipe(data_lia_appli)==-1)
    perror("data_lia_appli");
  
  if(pipe(disconnect_appli_lia)==-1)
    perror("disconnect_appli_lia");
  
  if(pipe(disconnect_lia_appli)==-1)
    perror("disconnect_lia_appli");


  if(pipe(data_phys_lia)==-1)
    perror("data_phys_lia");
  
  if(pipe(data_lia_phys)==-1)
    perror("data_lia_phys");
  
  if(pipe(disconnect_phys_lia)==-1)
    perror("disconnect_phys_lia");
  
  if(pipe(disconnect_lia_phys)==-1)
    perror("disconnect_lia_phys");
  

  /*--------------- Lancement des trois couches ------------------*/
  
  switch(fork())
    {
    case (pid_t) -1 : perror("fork_appli_lia"); exit(1); 
      
    case (pid_t) 0 :			/* fils */

      switch(fork())
	{
	case (pid_t) -1 : perror("fork_lia_phys"); exit(1); 
	  
      /*-------------- processus couche physique -------------------- */

	case (pid_t) 0 :	        /* petit fils */
	  
	  InitCouchePhys(&CchPhys, atoi(argv[1]), 
			data_lia_phys[0], data_phys_lia[1], 
			disconnect_lia_phys[0], disconnect_phys_lia[1]);
	  break; 

      /*-------------- processus couche liaison -------------------- */

	default        :                /* fils */
	  
	  InitCoucheLia(&CchLia, atoi(argv[1]), 
			connect_lia_appli[1], connect_appli_lia[0],
			data_lia_appli[1], data_appli_lia[0], 
			disconnect_lia_appli[1], disconnect_appli_lia[0], 
			data_lia_phys[1], data_phys_lia[0], 
			disconnect_lia_phys[1], disconnect_phys_lia[0]);
	  break; 
	}

      /*-------------- processus couche application ------------------*/

    default :			        /* pere */
	
      InitCoucheAppli(&CchAppli, atoi(argv[1]), 
		      connect_lia_appli[0], connect_appli_lia[1], 
		      data_lia_appli[0], data_appli_lia[1], 
		      disconnect_lia_appli[0], disconnect_appli_lia[1]);
      break; 
    }
}
