
/*===============================================*\

	Mardi 3 novembre 1998

	Arash HABIBI

	Codage.c

	A partir d'une chaine d'information en clair
	prepare un message code. 

\*================================================*/


#include "CodageDecodage.h"


void RecopieBitsDonneesEnc(char *message, CarCode_t *message_code, int taille_message)
/*===============================================*\
  Recopie les donnees en clair contenu dans message 
  aux bons emplacements dans message_code.
\*===============================================*/
{
  int i; 
        
  for(i=0; i<taille_message; i++)
    {
      /* Le polynome generateur est de degre 4 donc les 4 premier */
      /* bits sont reserves pour les bits de controle.            */

      SetNiemeBitCC(&(message_code[i]), 1,  0);
      SetNiemeBitCC(&(message_code[i]), 2,  0);
      SetNiemeBitCC(&(message_code[i]), 3,  0);
      SetNiemeBitCC(&(message_code[i]), 4,  0);
      SetNiemeBitCC(&(message_code[i]), 5,  NiemeBit(message[i], 1)); 
      SetNiemeBitCC(&(message_code[i]), 6,  NiemeBit(message[i], 2)); 
      SetNiemeBitCC(&(message_code[i]), 7,  NiemeBit(message[i], 3)); 
      SetNiemeBitCC(&(message_code[i]), 8,  NiemeBit(message[i], 4)); 
      SetNiemeBitCC(&(message_code[i]), 9,  NiemeBit(message[i], 5)); 
      SetNiemeBitCC(&(message_code[i]), 10, NiemeBit(message[i], 6)); 
      SetNiemeBitCC(&(message_code[i]), 11, NiemeBit(message[i], 7)); 
      SetNiemeBitCC(&(message_code[i]), 12, NiemeBit(message[i], 8)); 
    }
}



void CalculBitsCtrl(CarCode_t *message_code, int taille_message)
/*===============================================*\
  A partir du message code, et de sa 
  longueur, prepare les bits de controle 
  De facon a garder rester pair. 
\*===============================================*/
{
  int i; 
  CarCode_t cntrl=0; 

  for(i=0; i<taille_message; i++)
    {
      TronquerANbits(&(message_code[i]), 12);
      /* Met a Zero les bits 13, 14, 15 et 16 */
      
      cntrl = ResteDivisionModulo2(message_code[i], GENERATEUR);

      SetNiemeBitCC(&(message_code[i]), 1, NiemeBit(cntrl, 1));
      SetNiemeBitCC(&(message_code[i]), 2, NiemeBit(cntrl, 2)); 
      SetNiemeBitCC(&(message_code[i]), 3, NiemeBit(cntrl, 3)); 
      SetNiemeBitCC(&(message_code[i]), 4, NiemeBit(cntrl, 4)); 
    }
}



void Codage(char *message, int taille_message, char *message_code, int *taille_msg_code)
/*===============================================*\
  D'abord copier les donnees de message dans 
  message_code, puis calculer les bits de 
  controle. 
\*===============================================*/
{
  int i;
  
  *taille_msg_code = taille_message * sizeof(CarCode_t);

  RecopieBitsDonneesEnc(message, (CarCode_t*)message_code, taille_message);
  CalculBitsCtrl((CarCode_t*)message_code, taille_message); 
}
