
/*===============================================*\
	Mardi 3 novembre 1998

	Arash HABIBI

	Reception.c

	Lit les messages sur la socket et les ecrit 
	dans un fichier. 

\*================================================*/


#include "SocketToolbox.h"
#include "CodageDecodage.h"


int ReceiveMessage(int desc_sock, char *message)
/*===============================================*\
  L'information arrivant sur la socket est codee. 
  Cette fonction recoit le message code' sur la 
  socket, le decode pour avoir le message en clair. 
  (l'information seule) Rend le nombre de caracteres 
  recus dans le message en clair. 
  On detecte aussi la fin du fichier avec la fonction
  PointIsData. 
\*===============================================*/
{
  static int stop=0; 
  char message_code[MAX_MSG_CODE];
  int res, taille_msg_code, taille_message, taille_adresse=110; 
  struct sockaddr_un adresse_dist; 

  if(stop)
    return(0); 
  else
    {
      taille_msg_code = recvfrom(desc_sock, message_code, MAX_MSG_CODE, 0, 
			      (struct sockaddr *) &adresse_dist,
			      &taille_adresse); 
      
      if((taille_msg_code==1)&&(message_code[0]=='.'))
	if(PointIsData(desc_sock))
	  stop=1; /* mais la prochaine fois, il faudra sortir */
	else
	  return(0);

      else if(taille_msg_code>0)
	{
	  Decodage(message_code, taille_msg_code, message, &taille_message); 
	  return(taille_message);
	}
      else
	return(-1);
    }
}


int PointIsData(int desc_sock)
/*===============================================*\
  Lorsque tout le fichier a ete emis, l'emetteur
  envoie un caractere '.' 
  Or la transmission du fichier pourrait tres bien
  se terminer par l'emission d'un message contenant
  un seul '.' 
  Mais dans ce cas, apres avoir envoye ce dernier 
  message d'information, l'emetteur renvoie '.'
  Donc lorsqu'on recoit un '.' seul, il faut savoir 
  s'il s'agit d'une information ou d'un fin de 
  fichier. 
  Pour cela, apres avoir recu un '.' seul, on 
  attend encore une seconde (sleep(1))
  Si le '.' est suivi par un deuxieme '.', alors
  c'est que le premier etait un '.' d'information. 
  Sinon, on supposera que '.' est un point 
  indiquant un fin de fichier. 
\*===============================================*/
{
  int taille, taille_adresse=110, nonbloquant=1; 
  struct sockaddr_un adresse_dist; 
  char message_code[MAX_MSG_CODE]; 

  sleep(1);

  /* Pour pouvoir lire sur la socket, sans rester bloque */
  ioctl(desc_sock, FIONBIO, &nonbloquant);

  taille = recvfrom(desc_sock, message_code, MAX_MSG_CODE, 0, 
		    (struct sockaddr *) &adresse_dist,
		    &taille_adresse); 

  if((taille==1)&&(message_code[0]=='.'))
    return(1); 
  else
    return(0);
}
  
  

void main(int argc, char **argv)
/*===============================================*\
  Ouvre et prepare une socket unix, ouvre un 
  fichier en ecriture, lit les messages arrivant
  sur la socket et ecrit les messages recus dans 
  le fichier. 
  La reception des messages se fait avec la 
  fonction ReceiveMessage definie ci-dessus. 
\*===============================================*/
{
    int SaveFile, taille, res, desc_sock, 
      taille_adresse=110, stop=0;
    struct sockaddr_un adresse_dist; 
    mode_t mode; 
    char message[MAX_MESSAGE]; 
	
    if(argc!=2)
	{printf("Usage : recepteur FichRecu \n"); 
	 printf("FichRecu est le nom sous lequel le fichier recu\n");
	 printf("devra etre sauvegarde.\n");
	 exit(1);}


/* ----- Creation et attachement de la socket locale ------*/
/* ----- Ouverture du fichier ou seront sauvegardees ------*/
/* ----- les donnees arrivant sur la socket ---------------*/

    mode = S_IRUSR|S_IWUSR; 

    if((SaveFile=open(argv[1], O_WRONLY|O_CREAT|O_TRUNC, mode))==-1)
	{perror(argv[1]); exit(1);}

    desc_sock = GetAndBindSocket("sock_rec");
    

/* ----- Transmission -------------------------------------*/
	
    printf("Pret a recevoir.\n");

    do
      {
	taille = ReceiveMessage(desc_sock, message);

	if(taille<0)
	  {perror("reception socket"); exit(1);}

	else if(taille>0)
	  {
	    res = write(SaveFile, message, taille);
	    if(res==-1) {perror("ecriture recepteur"); exit(1);}
	  }

	else if(taille==0)
	  stop=1; 
      }
    while(!stop);


/* ----- Fin de la transmission ----------------------------*/

    printf("Reception terminee.\n");
    close(desc_sock);
    close(SaveFile);
    remove("sock_rec");
}	 



