
/*===============================================*\
	Mercredi 9 Septembre 1998

	Arash HABIBI

	ServeurTCP.c

	Un programme qui attend trois connexions
	venant de clients et leur attribue une 
	socket de service. Ensuite le serveur 
	transfere un fichier au client. 

	Attention le fichier SocketToolbox.c
	a change. Les fonctions RecoitFichier
	et TransfertFichier s'y sont ajoutees.  
	    
\*================================================*/


#include "SocketToolbox.h"


void main(int argc, char **argv)
/*===============================================*\
\*===============================================*/
{
	int i, res, sock_ecoute, sock_service, taille_adr; 
	AdresseIP_t IP;   /* le format n1.n2.n3.n4 */
	u_short port; 
	struct sockaddr_in adresse_loc, adresse_dist; 

	if(argc!=3) 
	{printf("Usage : serveur num_port NomFich\n"); exit(1);}
	
/*-------- Creation et attachement de la socket d'ecoute ---------*/
	
	sock_ecoute = GetAndBindSocket(SOCK_STREAM, 
		atoi(argv[1]), &adresse_loc);
	
	printf("Serveur TCP sur port numero %d\n",
		adresse_loc.sin_port);
		
/*-------- Debut de l'ecoute (Entree en service du serveur) ------*/
			
	res = listen(sock_ecoute, 10);
	
	if(res == -1) {perror("listen"); exit(1);}
	else printf("Serveur TCP commence l'ecoute\n");
	
/*-------- La boucle de l'acceptation de la demande de ------------*/
/*----- connexion des deux clients + transfert de fichier ---------*/

	taille_adr = sizeof(adresse_dist);

	for(i=0; i<2; i++)
	{
		sock_service = accept(sock_ecoute, 
			(struct sockaddr *)&adresse_dist, 
			&taille_adr);
		if(res==-1) {perror("accept");}
		
		/* connexion acceptee --------------------*/

		ReadNetworkAddress(adresse_dist, &IP, &port);
			
		printf("Demande de connexion venant de l'hote\
		      \n%d.%d.%d.%d du port numero %d.\
		      \nLa socket de service est le numero %d\
		      \nTransfert du fichier %s\n\n",
		      IP.n1, IP.n2, IP.n3, IP.n4, port, 
		      sock_service, argv[2]);
		      
		/*---- transfert de fichier ---------------*/

		TransfertFichier(sock_service, argv[2]);
	
		close(sock_service); /* de la socket de service -------------*/
	}
	
/*---------- Fermeture de la socket d'ecoute ----------------------*/

	res = close(sock_ecoute);
	if(res==-1) perror("close");
}

