
/*===============================================*\
	Samedi 19 Septembre 1998

	Arash HABIBI

	ServeurTCP.c

	Un serveur qui attend deux connexions
	et qui transmet tel quel tout ce qu'envoie
	l'un a l'autre et reciproquement. 

	Une petite variante : avec un traitement 
	qui transforme les minuscules en majuscules. 

\*================================================*/


#include <sys/time.h>

#include "SocketToolbox.h"


void ConnexionServeur(short port_loc, int *sock_ecoute, int sock_service[])
/*===============================================*\
\*===============================================*/
{
	struct sockaddr_in adresse_loc, adresse_dist;
	int i, res, taille_adr, nb_pendants=2; 
	AdresseIP_t IP; 
	u_short port_dist;
	
/*-------- Creation et attachement de la socket d'ecoute ---------*/
	
	*sock_ecoute = GetAndBindSocket(SOCK_STREAM, 
		port_loc, &adresse_loc);
	
	printf("serveur TCP attache au port numero %d\n",
		adresse_loc.sin_port);
		
		
/*-------- Debut de l'ecoute (Entree en service du serveur) ------*/
			
	res = listen(*sock_ecoute, nb_pendants);
	if(res == -1) {perror("listen"); exit(1);}
	
/*-------- La boucle de l'acceptation de la demande de cnxn -------*/

	for(i=0; i<2; i++)
	{
		if(i==0) printf("serveur TCP attend premier client\n");
		else  printf("serveur TCP attend second client\n");
		
		taille_adr = sizeof(adresse_dist);

		sock_service[i] = accept(*sock_ecoute, 
			(struct sockaddr *)&adresse_dist, 
			&taille_adr);
		if(res==-1) {perror("accept");}
		
		/* --------connexion acceptee ------------*/

		ReadNetworkAddress(adresse_dist, &IP, &port_dist);
			
		if(i==0)
		printf("Premiere demande de connexion venant de l'hote\n");
		else 
		printf("Seconde demande de connexion venant de l'hote\n");
		
	     	printf("%d.%d.%d.%d du port numero %d.\
	     		\nLa socket de service est le numero %d\n\n",
			IP.n1, IP.n2, IP.n3, IP.n4, port_dist, 
			sock_service[i]);
	}
}


void Traitement(char *message, int taille)
/*===============================================*\
  En l'occurrence change tous les minuscules en 
  majuscule et laisse le reste tel qu'il est. 
\*===============================================*/
{
    int i;

    for(i=0; i<taille; i++)
	if((message[i]>='a')&&(message[i]<='z'))
	    message[i] += 'A' - 'a'; 
}


int Echange(int sock_rec, int sock_send)
/*===============================================*\
  D'apres select nous savons qu'il y a 
  quelque chose a lire sur sock_rec. 
  Le but de cette fonction est de lire
  ce quelque chose et de l'envoyer sur 
  sock_send. 
  La fonction rend -1 en cas d'erreur 
  et 1 si tout va bien. 
\*===============================================*/
{
    int nb_rec, nb_sent;
    char message[100]; 
    
    nb_rec = read(sock_rec, message, 10);
    
    if(nb_rec<=0) {perror("read socket"); 
    	return(-1);}
    
    else if(nb_rec>0)
	{
	    Traitement(message,nb_rec);

	    nb_sent = write(sock_send, message, nb_rec);

	    if(nb_sent<0) {perror("write socket"); 
	    	return(-1);}
	    
	    else if(nb_sent==0) 
		{printf("socket distante disconnectee sans preavis.\n");
		     return(-1);}
	    
	    else if(nb_sent>0) 
		    /* rien a faire tout va bien*/
		    return(1);
	}
}

int Max(int n1, int n2, int n3)
/*===============================================*\
  Pour connaitre la valeur du descripteur le 
  plus grand. 
\*===============================================*/
{
    if(n2>n1)
	if(n3>n2) return(n3); 
	else return(n2);
    else
	if(n3>n1) return(n3);
	else return(n1); 
}


void main()
/*===============================================*\
\*===============================================*/
{
    int terminal, sock_ecoute, sock_service[2]; 
    int stop, crash;
    int nbfds, nb_events, nb_lu, nb_recu, res; 
    fd_set lecture, ecriture, except;
    
/*-------- Connexion ------------------------------------*/
    
    ConnexionServeur(0, &sock_ecoute, sock_service);
    crash = 0; stop=0;
    
/*-------- Ouverture du terminal de controle ------------*/
    
    terminal = open("/dev/tty", O_RDWR);
    if(terminal==-1) {perror("terminal"); exit(1);}
    
/*-------- Elements permanents de select ----------------*/
    
    nbfds = Max(sock_service[0], 
		sock_service[1], 
		terminal) + 1;
    
/*-------- La boucle de traitement des evenements --------*/

    printf("RETURN pour arreter le serveur a tout moment.\n\n");
    
    while((!crash)&&(!stop))
	{
	    /*---- Preparation des ensembles -------- */
	    /*--------- de descripteurs ------------- */
	    
	    FD_ZERO(&lecture); 
	    FD_ZERO(&ecriture); 
	    FD_ZERO(&except); 
	    FD_SET(terminal, &lecture); 
	    FD_SET(sock_service[0], &lecture); 
	    FD_SET(sock_service[1], &lecture); 
	    
	    /*------- attente d'un evenment --------- */
	    
	    nb_events = select (nbfds, &lecture, &ecriture, 
				&except, NULL);
	    
	    if(nb_events==-1) {perror("select"); crash=1;} 
	    
	    /*------- le depouillement des votes ---- */
	    
	    if(FD_ISSET(sock_service[0], &lecture))
		{
		    res = Echange(sock_service[0], 
				  sock_service[1]);
		    
		    if(res<=0) crash=1; 
		    else if(res>0) /* tout va bien */;
		}
	    
	    if(FD_ISSET(sock_service[1], &lecture))
		{	
		    res = Echange(sock_service[1], 
				  sock_service[0]);
		    
		    if(res<=0) crash=1; 
		    else if(res>0) /* tout va bien */;
		}

	    if(FD_ISSET(terminal, &lecture)) stop=1;
	}
    
    close(sock_service[0]);
    close(sock_service[1]);
    close(sock_ecoute);
    
    if(crash)
	printf("Echange interrompu\n\n");
    else if(stop)
	printf("Echange termine. Deconnexion.\n\n");
}

